# Troubleshooting

If you're having a problem with Brim, please browse the following sections
before you [open an issue](#opening-an-issue).

- [Common Problems](#common-problems)
  * [I've clicked to open a packet capture in Brim, but it failed to open](#ive-clicked-to-open-a-packet-capture-in-brim-but-it-failed-to-open)
  * [I've clicked in Brim to extract a flow from my pcap into Wireshark, but the flow looks different than when I isolate it in the original pcap file in Wireshark](#ive-clicked-in-brim-to-extract-a-flow-from-my-pcap-into-wireshark-but-the-flow-looks-different-than-when-i-isolate-it-in-the-original-pcap-file-in-wireshark)
  * [Brim seems unable to restart normally, such as after a bad crash](#brim-seems-unable-to-restart-normally-such-as-after-a-bad-crash)
  * [Brim shows "Connection Error: The service at localhost:9867 could not be reached"](#brim-shows-connection-error-the-service-at-localhost9867-could-not-be-reached)
- [Gathering Info](#gathering-info)
  * [Sensitive Information (important!)](#sensitive-information-important)
  * [Screenshots/Videos](#screenshotsvideos)
  * [Developer Tools](#developer-tools)
  * [Logs](#logs)
  * [Sample Packet Captures](#sample-packet-captures)
  * [Large Files](#large-files)
- [Opening an Issue](#opening-an-issue)

# Common Problems

## I've clicked to open a packet capture in Brim, but it failed to open

There are two different broad categories of such problems, one involving the
application configured to open packet capture files and the other involving
the packet captures themselves. The sections below describe each category in
detail.

### Application problems

To start debugging such problems, it helps to understand how Brim opens flows
extracted from pcaps. Once the 5-tuple, connection start time, and connection
duration are isolated from the Zeek `conn` record for the flow, the
[`zqd`](https://github.com/brimdata/zed/tree/main/ppl/cmd/zqd) process uses an
index to extract the packets for the target flow into a temporary file. Once
this temporary file has been written to the local filesystem, the application
on your operating system that's configured to automatically open files ending
in `.pcap` will be launched to open this file.

In typical environments, that application will be Wireshark. However, if no
such application is installed or configured to open `.pcap` files, clicking the
**Packets** button in Brim will have no effect. The lack of guidance in this
 case is currently lacking on macOS and Linux
([brim/1379](https://github.com/brimdata/brim/issues/1379)).

To fix this problem, ensure Wireshark or a similar utility is installed
and that you can open `.pcap` files outside of Brim by double-clicking them
in the general "files" utility for your operating system.

Note that it would be a misconfiguration to set Brim itself as your operating
system's default application for opening `.pcap` files, as this would make
Brim's **Packets** button "point at itself".

### Packet capture problems

If you are able to open a pcap file in Wireshark but not extract flows from it
in Brim, it's likely a problem unique to the packet capture itself. 

Unfortunately, not all packet captures are created equal. The library that
Brim invokes to extract flows from your pcap handles the most common variations
we've encountered, but you may have come across a corner case that it wasn't
prepared to handle.

Such problems are often due to file format variations that are unique to the
system that generated the capture. In such situations, the most expedient debug
path would be to send us the capture file so our developers can use it to
reproduce the problem, fix it, and create automated tests to ensure the problem
doesn't arise again in the future. We understand that concerns regarding
[sensitive information](#sensitive-information-important)
may make it difficult or impossible to share such data. If the specific
capture with which you first saw the problem cannot be shared, an alternative 
approach would be to share a special debug capture generated by the same
system, but made up of traffic known to be innocuous (e.g. performing a
`curl` to a common public web site). If you're able to share your original
capture file, or can share a special debug capture that also reproduces the
problem, please [open a bug report](#opening-an-issue) and attach it along with
a [screenshot](#screenshotsvideos) or cut & paste of any error message you saw
in Brim. These alone should be adequate for us to start working on a fix.
However, if you cannot share your data, proceed with the following steps.

First, if you don't see an error message in Brim, or the error seems terse and
unhelpful, it may help us get to the bottom of it faster if you include the
debug info from [Developer Tools](#developer-tools).

Beyond that, the most comprehensive way to debug is to use a tool at the
command line to perform steps that are functionally equivalent to those
initiated by the Brim application to extract flows from your pcap. This will
allow you to better observe the individual steps so you can report the point at
which you see a failure. This consists of the following steps:

1. Locate the `pcap` utility that's bundled with Brim. This binary can be
found in the following location on each platform:

   |**OS Platform**|**Location**|
   |---------------|------------|
   | **Windows**   | `%USERPROFILE%\AppData\Local\Brim\app-<version>\resources\app\zdeps` |
   | **macOS**     | `/Applications/Brim.app/Contents/Resources/app/zdeps` |
   | **Linux**     | `/usr/lib/brim/resources/app/zdeps`                   |


   ```
   $ pcap
   NAME
       pcap - pcap creates time index files for pcaps

   USAGE
       pcap [global options] command [options] [arguments...]
   ...
   ```

2. Build a packet index for your capture file. For example, assuming a capture
in a file named `hello.pcapng`:
   ```
   $ pcap index -r hello.pcapng -x hello.idx
   ```

3. Print some sample packet timestamps from your capture. An example output
from our sample pcap (your timestamps will differ):
   ```
   $ ./pcap ts -r hello.pcapng 
   1583768523.826851
   1583768523.826857
   1583768523.826968
   ...
   ```
4. To extract a portion of the capture by using the index, create a
`pcap slice` command line like the one shown below. Use any of the timestamps
near the top of the output in step #3 as the `-from` parameter and a
timestamp from later in the output as the `to` parameter. An example command
line (your timestamps will differ):
   ```
   $ ./pcap slice -x hello.idx -r hello.pcapng -from 1583768523.826851 -to 1583768523.826968 > tmp.pcapng
   ```

Brim normally invokes steps similar to those shown above by making API calls
to the [`zqd`](https://github.com/brimdata/zed/tree/main/ppl/cmd/zqd) process that
is launched when Brim starts. Specifically, step #2 is performed when you import
your pcap into Brim, then information from the generated Zeek `conn` records
provide timestamps similar to those you gathered in step #3, and then the
extraction performed in step #4 should result in a packet capture file that's
readable in Wireshark.

If you run through the above steps using a pcap for which you've successfully
opened flows in Brim before, the `tmp.pcapng` that's output in the last step
should, indeed, open successfully in Wireshark. Then when you run through the
same steps using your problem pcap, one of the above steps should produce
errors that you can paste into your [bug report](#opening-an-issue) to help us
understand the problem.

## I've clicked in Brim to extract a flow from my pcap into Wireshark, but the flow looks different than when I isolate it in the original pcap file in Wireshark

Brim uses [Zeek](https://zeek.org/) to create summary logs from pcaps. 
Zeek and Wireshark for the most part treat flows similarly. But we're aware 
of some subtle differences that you may notice, and
there may be other differences of which we're not yet aware.

In Wireshark, you can right-click on a TCP/UDP packet and select _Follow TCP
Stream_ or _Follow UDP Stream_, which will apply a filter of the format
`tcp.stream eq N` or `udp.stream eq N`, where `N` is a number `0`, `1`, etc.
based on which flow within the pcap is being isolated. When this is done,
Wireshark appears to treat all packets as part of the same flow if they
share the same [5-tuple](https://www.caida.org/research/traffic-analysis/flowtypes/),
regardless of how long the flow lasts.

Separately, Brim relies on Zeek's `conn` event, which includes the `id` and
`proto` fields that capture the 5-tuple for a flow, along with the fields for
`ts` (time of first packet) and `duration` (how long the connection lasted).
Brim uses all this information to extract the flow from the indexed pcap file.
However, this is where Zeek's occasionally different perception of flows may
come into play.

For starters, Zeek's [`conn` documentation](https://docs.zeek.org/en/current/scripts/base/protocols/conn/main.zeek.html#type-Conn::Info)
discloses that the time span covered by the `duration` field "will not include the final ACK [...] for 3-way or 4-way [TCP] connection tear-downs". Therefore
a TCP flow extracted via Brim is likely to be missing such an ACK.

Separately, for UDP flows, Zeek has a `udp_inactivity_timeout` that defaults to
one minute. This means that UDP flows that don't send or receive traffic for
60 seconds will have their flow state "flushed" from Zeek into a completed
`conn` event. If the flow is actually still active in the capture such that
more packets for the 5-tuple reappear after the 60 second timeout, a new `conn`
record would be created by Zeek (and hence would appear separately in Brim, and
therefore be extracted from the original pcap as if it were a separate flow).

These represent what we expect may be the majority of observed differences in
flow handling. However, through side-by-side study of Wireshark next to Zeek,
we've uncovered the following additional corner cases that may also yield
differences:

|**Issue**|**Description**|
|-|-|
|[zeek/846](https://github.com/zeek/zeek/issues/846)|"ts+duration" for TCP flow is missing more than just ACK|
|[zeek/847](https://github.com/zeek/zeek/issues/847)|Zeek creates many conn records for DNS despite `udp_inactivity_timeout=0`|
|[zeek/862](https://github.com/zeek/zeek/issues/862)|Retransmissions of unsuccessful close attempt keep getting flagged as new connections|
|[zeek/864](https://github.com/zeek/zeek/issues/864)|Multi-section pcapng with overlapping timestamps creates excess `conn` events|
|[zeek/1163](https://github.com/zeek/zeek/issues/1163)|Full precision of nanosecond timestamps is not preserved|

If you find yourself running into these issues or others of a similar nature,
please reach out to us on our [public Slack](https://www.brimsecurity.com/join-slack/)
or [open an issue](#opening-an-issue) and we'll try to help.

## Brim seems unable to restart normally, such as after a bad crash

Though we attempt to fix bad bugs in Brim soon after they're identified,
occasionally you may encounter a new bug that crashes the app in a way that
leaves it in a bad state. In these situations Brim will seem "stuck" each time
it starts, either at at a blank white screen (such as in previously-fixed issue
[#1099](https://github.com/brimdata/brim/issues/1099)) or showing an error dump
similar to the one below:

![Example crash from issue #652](media/Crash-652.png)

If you experience such a crash, please gather any error dump text and
[open an issue](#opening-an-issue) with as much detail as possible regarding
the steps you followed that led up to the crash.

Then to clear the condition, click **Window > Reset State** from the Brim
pull-down menu. This will clear some cached data from your previous use of Brim
(e.g. the contents of the **History** panel), but the data for your Spaces will
remain intact.

Before resuming normal work in Brim, this would be a good opportunity to
retrace your steps and confirm that you've captured the reproduction steps
accuately in your [issue](#opening-an-issue), since you won't lose any history
if you repro/crash Brim and clear it one more time. Your assistance in helping
us squash these types of bad bugs is much appreciated. Thank you!

## Brim shows "Connection Error: The service at localhost:9867 could not be reached"

The following screenshot shows how this error is presented in Brim.

![Service could not be reached](media/Conn-Err-could-not-be-reached.png)

These failures are quite rare. Brim is regularly tested for successful
installation in "out-of-the-box" configurations of all supported platforms, so
it's likely that this type of failure may be due to some unique configuration
on your system that's preventing normal operation. Therefore, even if the tips
below help you get past the problem, it would be very helpful for you to still
share the details with us so we can provide guidance to ensure other users
avoid the problem in the future.

There have been a couple reports from Windows users who experienced these
symptoms after an upgrade to a newer Brim release. In each case the users
ultimately resolved the problem via system reboot. We've unfortunately been
unable to reproduce this problem or study a system "live" that's in this state
to determine the root cause or why the reboot fixed it. An issue
[brim/1490](https://github.com/brimdata/brim/issues/1490) is being kept open to
track this specific case. Even though a reboot might be an effective fix for
you also, your assistance would be much appreciated in still running
through the troubleshooting steps below and gathering the debug information.
If you ultimately find a reboot fixes the symptom for you, please add your logs
and details to [brim/1490](https://github.com/brimdata/brim/issues/1490).
In all other cases, please [open a new issue](#opening-an-issue).

To begin troubleshooting this, it helps to understand the "backend" of Brim.
One essential component is [`zqd`](https://github.com/brimdata/zed/tree/main/ppl/cmd/zqd),
a server-style process that manages the storage and querying of imported
log/packet data. Operations in `zqd` are invoked via a
[REST API](https://en.wikipedia.org/wiki/Representational_state_transfer)
that's utilized by a "client", such as the Brim app. When run on your desktop,
`zqd` is launched at startup by Brim and then listens for such API connections
on local TCP port `9867`.

![Brim connecting to zqd on 9867](media/Brim-zqd-9867.png)

Therefore, this particular error message indicates that for some reason Brim
was not able to successfully communicate with a `zqd` process via
`localhost:9867`. In brief, the root cause is likely one of the following:

1. [A `zqd` crash](#a-zqd-crash)
2. [A failure to launch `zqd`](#a-failure-to-launch-zqd)
3. [No local communications between Brim and `zqd`](#no-local-communications-between-brim-and-zqd)

In all cases, you should plan to [open an issue](#opening-an-issue) with
Brim/`zqd` logs attached, as these may include crash/failure details. However,
for situations other than simple crashes, the problem may be related to
anti-virus tools that could block the install/upgrade of software, and/or
firewalls that block communications between unfamiliar processes. You may
therefore need to work with your IT department to examine logs from such
utilities and determine if settings can be adjusted to allow Brim to operate.

The sections below describe additional debug you can perform to narrow down
among the above root causes. Please include your findings from these steps in
any issue you open, along with Brim/`zqd` logs and details on how you
reproduced the error.

### A `zqd` crash

If you experience the error during normal operations in Brim (e.g. after you've
attempted to execute a query in the middle of an otherwise healthy session),
it's possible that the `zqd` process suffered a fatal crash. If you can
reliably reproduce the crash by executing a particular query and/or with a
particular data source, please include this detail in your issue along with
attached logs.

### A failure to launch `zqd`

If you experience the error when launching Brim (perhaps after an auto-update
to a new release), it's possible that system utilities prevented the `zqd`
process from fully installing or starting. To narrow down if this is occurring,
it may help to compare the current running state to that of a healthy
installation.

Once you've launched Brim and have observed the error message, check the
running processes on your system and compare to the outputs shown below as
appropriate for your platform.

**Windows (Task Manager)**

![Healthy Brim in Task Manager](media/Brim-Task-Manager.png)

**Linux [`pstree`](https://man7.org/linux/man-pages/man1/pstree.1.html)**

```
$ pstree
...
        |      |                 |               |                 |-gnome-shell-+-Brim-+-Brim---Brim-+-Brim
        |      |                 |               |                 |             |      |             `-4*[{Brim}]
        |      |                 |               |                 |             |      |-Brim---Brim
        |      |                 |               |                 |             |      |-Brim---4*[{Brim}]
        |      |                 |               |                 |             |      |-Brim---10*[{Brim}]
        |      |                 |               |                 |             |      |-zqd---9*[{zqd}]
        |      |                 |               |                 |             |      `-30*[{Brim}]
```

**macOS [`pstree`](https://man7.org/linux/man-pages/man1/pstree.1.html)**

```
$ pstree
...
 |-+= 51968 phil /Applications/Brim.app/Contents/MacOS/Brim
 | |--- 51969 phil /Applications/Brim.app/Contents/Frameworks/Brim Helper (GPU).app/Contents/MacOS/Brim Helper (GPU) --type=gpu-process --field-trial-handle=1718379636,14112076954270201284,13380727289785404389,131072 --enable-features=WebComponentsV0Enabled --disable-features=CookiesWithoutSameSiteMustBeSecure,SameSiteByDefaultCookies,SpareRendererForSitePerProcess --gpu-preferences=MAAAAAAAAAAgAAAAAAAAAAAAAAAAAAAAAABgAAAAAAAQAAAAAAAAAAAAAAAAAAAA6AAAABwAAADgAAAAAAAAAOgAAAAAAAAA8AAAAAAAAAD4AAAAAAAAAAABAAAAAAAACAEAAAAAAAAQAQAAAAAAABgBAAAAAAAAIAEAAAAAAAAoAQAAAAAAADABAAAAAAAAOAEAAAAAAABAAQAAAAAAAEgBAAAAAAAAUAEAAAAAAABYAQAAAAAAAGABAAAAAAAAaAEAAAAAAABwAQAAAAAAAHgBAAAAAAAAgAEAAAAAAACIAQAAAAAAAJABAAAAAAAAmAEAAAAAAACgAQAAAAAAAKgBAAAAAAAAsAEAAAAAAAC4AQAAAAAAABAAAAAAAAAAAAAAAAAAAAAQAAAAAAAAAAAAAAAGAAAAEAAAAAAAAAAAAAAABwAAABAAAAAAAAAAAAAAAAgAAAAQAAAAAAAAAAAAAAAKAAAAEAAAAAAAAAAAAAAACwAAABAAAAAAAAAAAAAAAA0AAAAQAAAAAAAAAAEAAAAAAAAAEAAAAAAAAAABAAAABgAAABAAAAAAAAAAAQAAAAcAAAAQAAAAAAAAAAEAAAAIAAAAEAAAAAAAAAABAAAACgAAABAAAAAAAAAAAQAAAAsAAAAQAAAAAAAAAAEAAAANAAAAEAAAAAAAAAAEAAAAAAAAABAAAAAAAAAABAAAAAYAAAAQAAAAAAAAAAQAAAAHAAAAEAAAAAAAAAAEAAAACAAAABAAAAAAAAAABAAAAAoAAAAQAAAAAAAAAAQAAAALAAAAEAAAAAAAAAAEAAAADQAAABAAAAAAAAAABgAAAAAAAAAQAAAAAAAAAAYAAAAGAAAAEAAAAAAAAAAGAAAABwAAABAAAAAAAAAABgAAAAgAAAAQAAAAAAAAAAYAAAAKAAAAEAAAAAAAAAAGAAAACwAAABAAAAAAAAAABgAAAA0AAAA= --use-gl=swiftshader-webgl --shared-files
 | |--- 51971 phil /Applications/Brim.app/Contents/Resources/app/zdeps/zqd listen -l localhost:9867 -data /Users/phil/Library/Application Support/Brim/data/spaces -config /Users/phil/Library/Application Support/Brim/zqd-config.yaml -suricatarunner /Applications/Brim.app/Contents/Resources/app/zdeps/suricata/suricatarunner -suricataupdater /Applications/Brim.app/Contents/Resources/app/zdeps/suricata/suricataupdater -zeekrunner /Applications/Brim.app/Contents/Resources/app/zdeps/zeek/zeekrunner -brimfd=3
 | |--- 51972 phil /Applications/Brim.app/Contents/Frameworks/Brim Helper.app/Contents/MacOS/Brim Helper --type=utility --utility-sub-type=network.mojom.NetworkService --field-trial-handle=1718379636,14112076954270201284,13380727289785404389,131072 --enable-features=WebComponentsV0Enabled --disable-features=CookiesWithoutSameSiteMustBeSecure,SameSiteByDefaultCookies,SpareRendererForSitePerProcess --lang=en-US --service-sandbox-type=network --shared-files --seatbelt-client=46
 | \--- 51973 phil /Applications/Brim.app/Contents/Frameworks/Brim Helper (Renderer).app/Contents/MacOS/Brim Helper (Renderer) --type=renderer --field-trial-handle=1718379636,14112076954270201284,13380727289785404389,131072 --enable-features=WebComponentsV0Enabled --disable-features=CookiesWithoutSameSiteMustBeSecure,SameSiteByDefaultCookies,SpareRendererForSitePerProcess --disable-gpu-compositing --lang=en-US --app-path=/Applications/Brim.app/Contents/Resources/app --enable-experimental-web-platform-features --node-integration --no-sandbox --no-zygote --enable-remote-module --background-color=#fff --enable-spellcheck --enable-websql --disable-electron-site-instance-overrides --num-raster-threads=4 --enable-zero-copy --enable-gpu-memory-buffer-compositor-resources --enable-main-frame-before-activation --renderer-client-id=4 --no-v8-untrusted-code-mitigations --shared-files
```

If `zqd` is absent from these outputs, it's possible that another process is
already running that's listening on TCP port 9867. To confirm this, completely
exit Brim and run `netstat -an` and look for instances of `:9867`.

If no such process is found, examine the logs of system utilities (perhaps
with assistance from an IT department) to look for indications of the `zqd`
binary not having having been fully installed (such as during auto-update to a
new release) or prevented from being launched.

### No local communications between Brim and `zqd`

If the process tables indicated `zqd` is running, the next thing to consider
is the local network connectivity. In an "out-of-the-box" desktop environment,
not only would Brim have been able to connect, but a direct connection from a
browser to `http://localhost:9867` would cause the following informational
message to be returned by `zqd`.

![zqd listening](media/zqd-listening.png)

It may help to use Wireshark to sniff TCP port 9867 traffic on your system's
loopback interface while attempting to access this URL in your browser. This
may help determine if packets are failing to make it to `zqd`, not being
returned from `zqd`, and/or if some other process is getting in the way of the
communications. It may be necessary to examine firewall logs (perhaps with
assistance from an IT department) to look for evidence of the connection
having been blocked.

# Gathering Info

Before [opening an issue](#opening-an-issue), or while debugging a
previously-opened issue, there's detail you can gather that may help us more
quickly provide you with a resolution.

## Sensitive Information (important!)

For all information described in this section, we understand that some of it
may be of a sensitive nature such that you don't feel you can attach it
directly to a public GitHub Issue. If you can crop, blur, or otherwise modify
the information before attaching, please do. If you feel you could share such
information only privately, please notify us on [public Slack](https://www.brimsecurity.com/join-slack/)
and we can arrange to receive it from you in a private 1-on-1 chat.

## Screenshots/Videos

If you think you've encountered a bug, a screenshot or recorded desktop video
of your Brim app that includes the error message or unexpected behavior may
help us a lot. If you can annotate your media with arrows, text, or other
detail, even better. The same is true if you're submitting a detailed feature request.

## Developer Tools

Most of Brim's error messages should be surfaced within the app and include
enough detail for us to figure out the problem. However, if you've uncovered a
challenging bug, we may need your help to gather some additional detail. For
instance, this may come up with bugs where you're clicking in the app and you
expect a certain outcome but nothing seems to be happening.

A more detailed level of debug info may be hiding in a _Developer_ _Tools_ area
that's available in Brim, and it may help us a lot if you could check there to
see if more error info is being generated when you reproduce a problem. This
will work best with bugs that you can reliably reproduce.

To prepare, get to the point in the Brim app where you're _about_ _to_ trigger
the problem, but have not triggered it yet. Then from the menu bar, select
**View > Toggle Developer Tools**. This will reveal a new panel on the right
side of the app window, as outlined in red below.

![Opening Developer Tools](media/Open_Dev_Tools.png)

Once the panel is revealed, inside it first click to the **Console** tab, then
click the circle with the line through it to clear the console of any existing
messages.

![Preparing Developer Tools](media/Prep_Dev_Tools.png)

Now perform the operation in the app that triggers the problem. Hopefully this
will reveal some error messages in the **Console** area of the panel. If this
is the case, please take a screenshot and include it with your issue.

## Logs

Logs are generated by the Brim app and the `zqd` process it launches (the
engine for querying your data). These are located in:

|**OS Platform**|**Location**|
|---------------|------------|
| **Windows**   | `%APPDATA%\Brim\logs` |
| **macOS**     | `$HOME/Library/Application Support/Brim/logs` | 
| **Linux**     | `$HOME/.config/Brim/logs` | 

Please include a ZIP of the contents of this directory along with any issue
you open to report a bug.

## Sample Packet Captures

If your problem involes a pcap file, we'll likely be able to debug much quicker
if you can attach a sample pcap file to your issue. If you are able to
reproduce the issue using a small pcap that you're certain does not contain
sensitive information, that would be ideal.

## Large Files

If you have a video or sample pcap that is too large to attach to a GitHub
Issue, please upload it to the file-sharing service of your choosing and paste
a link to it in your issue.

# Opening an Issue

Before/when [opening a new issue](https://github.com/brimdata/brim/issues/new/choose),
you can help us out by doing the following:

* Review the [common problems](#common-problems) above see if you're hitting one of those.
* Browse the existing [open issues](https://github.com/brimdata/brim/issues?q=is%3Aissue+is%3Aopen). If you confirm you're hitting one of those, please add a comment to it rather than opening a new issue.
* [Gather info](#gathering-info) that that may help in reproducing the issue and testing a fix, and attach it to your issue.
* Feel free to chat with the team on the [public Slack](https://www.brimsecurity.com/join-slack/) before/after opening an issue.
* When you open a new issue, its initial text will include a template with standard info that will almost always be needed. Please include detail for all areas of the template.

Thanks for helping us support the Brim community!
